#define WM_COMMAND 0x0111
#import "user32.dll"
	// p      
	int  RegisterWindowMessageA(string lpString); // pp p (  )
	// p   p . p :      p, 0 -  
	int  PostMessageA(int  hWnd,      // , p  p ,  $FFFF   pp   
					  int  Msg,       //  
                      int  wParam,    //  p  
                      string lParam); //  p  
#import

#property indicator_chart_window

bool tickTimeLocal = false;
string symbolName = "default";
bool tickChartUpdate = true;
int error = -1;
int hand1e = -1;
int fpos = -1;
double ask[];
double bid[];
int digit;
string symbol;
int MT4InternalMsg;
int time;
int hwnd;
bool initw, update = false;
bool flag = true;
string gvar;
string fp;
string sn;
int i;
int ?time;

int init(){
	gvar = (Symbol()+"eW");    
    if(GlobalVariableCheck(gvar) == false){
		initw = true;
		GlobalVariableSet(gvar,1.0);   
    }else{
		Print("out: second copy");
		initw = false;
		flag = false;
		return(0);
    }
	
	symbol = Symbol();
    digit  = MarketInfo(symbol, MODE_DIGITS) ;
    if(symbolName == "default"){
		sn = StringConcatenate("sec", symbol) ;
		fp = StringConcatenate(sn, 1,  ".hst") ;
    }else{
		sn = symbolName ;
		fp = StringConcatenate(symbolName, 1, ".hst") ;  
    }
	
	hand1e = FileOpenHistory(fp, FILE_BIN|FILE_READ);
    error = GetLastError();
	if( (hand1e<0) || (error == 4103)){
		hand1e = FileOpenHistory(fp, FILE_BIN|FILE_READ|FILE_WRITE);
		error = GetLastError();
		if(hand1e<0){
			Print("out: error(",error,"): ",ErrorDescription(error));
			flag = false;
		}else{
			update = false;
			int unused[13];
			FileWriteInteger(hand1e, 400, LONG_VALUE); 			 
			FileWriteString (hand1e, "", 64);				 
			FileWriteString (hand1e, sn, 12); 
			FileWriteInteger(hand1e, 1, LONG_VALUE);	 
			FileWriteInteger(hand1e, digit, LONG_VALUE);		 
			FileWriteInteger(hand1e, 0, LONG_VALUE);		  
			FileWriteInteger(hand1e, 0, LONG_VALUE);		 
			FileWriteArray  (hand1e, unused, 0, 13);
			FileFlush       (hand1e);
			if(FileSeek(hand1e, 0, SEEK_END) == false){ 
				error = GetLastError();
				Print("out: error(",error,"): ",ErrorDescription(error));
				flag = false;
			}else{
				fpos = FileTell(hand1e);  
			}
        }
    }else{
		FileClose(hand1e);
		hand1e = FileOpenHistory(fp, FILE_BIN|FILE_READ|FILE_WRITE);
		error = GetLastError();
		if(hand1e<0){
			Print("out: error(",error,"): ",ErrorDescription(error));
			flag = false;
        }else{
			update = true;
			if(FileSeek(hand1e, -44, SEEK_END) == false){ 
				error = GetLastError();
				Print("out: error(",error,"): ",ErrorDescription(error));
				flag = false;
			}else{	 
				time = FileReadInteger(hand1e,LONG_VALUE);
	        }	 
			if(FileSeek(hand1e, 0, SEEK_END) == false){ 
				error = GetLastError();
				Print("out: error(",error,"): ",ErrorDescription(error));
				flag = false;
			}else{
				fpos = FileTell(hand1e);   
			}
		}  
    }
	
	if(tickChartUpdate == true){
		if(MT4InternalMsg == 0) MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");
	}
	
	if(flag == true){
		if(tickTimeLocal == true) time = TimeLocal();
		else time = TimeCurrent();
	}
	return(0);
}

int deinit(){
	if(initw == true) GlobalVariableDel(gvar);
    if(hand1e >0) FileClose(hand1e);
    error = UninitializeReason(); 
    string temp;
    switch(error){
        case 0: temp = "REASON_independently"; break;
        case 1: temp = "REASON_REMOVE"; break;
        case 2: temp = "REASON_RECOMPILE"; break;
        case 3: temp = "REASON_CHARTCHANGE"; break;
        case 4: temp = "REASON_CHARTCLOSE"; break;
        case 5: temp = "REASON_PARAMETERS"; break;
        case 6: temp = "REASON_ACCOUNT"; break;
        }
	Print(StringConcatenate("out: ",temp));      
	return(0);
}

int start(){
	if(flag==true){
		if(tickTimeLocal==true){
			if(FileSeek(hand1e, fpos, SEEK_SET) == false){//    ,     FileTell
				error = GetLastError();// 
				Print("out: error(",error,"): ",ErrorDescription(error));//   
				flag = false;
				return(0);// 
			}else{
				FileWriteInteger(hand1e,  Time[0],   LONG_VALUE);//TimeLocal()
				FileWriteDouble (hand1e,  Open[0], DOUBLE_VALUE);//Open[]
				FileWriteDouble (hand1e,  High[0], DOUBLE_VALUE);//High[]
				FileWriteDouble (hand1e,  Low[0], DOUBLE_VALUE);//Low[]
				FileWriteDouble (hand1e,  Close[0], DOUBLE_VALUE);//Close[]
				FileWriteDouble (hand1e,  Volume[0], DOUBLE_VALUE);//Volume[]
				FileFlush       (hand1e);
				fpos = FileTell (hand1e);//    
			}
		}else{
			?time=TimeCurrent()-time;//  ,  TimeCurrent()     
			switch(?time){
				case 0 ://   
					AccumulatorOfTicks(false);//  -
					break;
				case 1 ://      
					WriteBar();//    
					AccumulatorOfTicks(true);//   
					break;
				default://      
					WriteBar();//    
					?time--; time++;//   , ..   
					while(?time!=0) WriteDash();//    - . .  
					AccumulatorOfTicks(true);//  
			}
		}
		if(tickChartUpdate == true){
			hwnd = WindowHandle(sn, 1);
			if(PostMessageA(hwnd, WM_COMMAND, 0x822C, 0) == false){//33324 -   (   )
				hwnd = 0;
				return(0);
			}
			PostMessageA(hwnd, MT4InternalMsg, 2, 1);
		}

	}
	return(0);
}

void WriteBar(){
	if(FileSeek(hand1e, fpos, SEEK_SET) == false){//    ,     FileTell
		error = GetLastError();// 
		Print("out: error(",error,"): ",ErrorDescription(error));//   
		flag = false;
		return;// 
	}else{
		FileWriteInteger(hand1e,  time,   LONG_VALUE);//TimeCurrent()
		FileWriteDouble (hand1e,  bid[0], DOUBLE_VALUE);//Open[]
		FileWriteDouble (hand1e,  bid[ArrayMaximum(bid)], DOUBLE_VALUE);//High[]
		FileWriteDouble (hand1e,  ask[ArrayMinimum(ask)], DOUBLE_VALUE);//Low[]
		FileWriteDouble (hand1e,  ask[ArraySize(ask)-1], DOUBLE_VALUE);//Close[]
		FileWriteDouble (hand1e,  ArraySize(ask), DOUBLE_VALUE);//Volume[]
		FileFlush       (hand1e);
		fpos = FileTell (hand1e);//    
		if(ArraySize(ask)==2) Alert(StringConcatenate(TimeToStr(TimeCurrent(), TIME_SECONDS), " - volume = ", ArraySize(ask)));
		if(bid[0]==ask[ArraySize(ask)-1]) Alert(StringConcatenate(TimeToStr(TimeCurrent(), TIME_SECONDS), " - bid=ask, Ticks = ", ArraySize(ask)));
		/* .     ..    (..   Open  Close
		 High  Low),       , ..    2 ,    
		   .       (..  )
		  ,  , -     Open  Close.*/
	}
}

void AccumulatorOfTicks(bool AtFirst){
	if (AtFirst){
		ArrayResize(bid, 1);//  
		ArrayResize(ask, 1);
		i=0;//    
		time=TimeCurrent();//    
	}else{
		ArrayResize(bid, i+1);
		ArrayResize(ask, i+1);
		i++;
	}
	bid[i]=MarketInfo(symbol, MODE_BID);
	ask[i]=MarketInfo(symbol, MODE_ASK);
	if (bid[i]==ask[i]) Alert("from accumulator: bid=ask");
}

void WriteDash(){
	if(FileSeek(hand1e, fpos, SEEK_SET) == false){//    ,     FileTell
		error = GetLastError();// 
		Print("out: error(",error,"): ",ErrorDescription(error));//   
		flag = false;
		return;// 
	}else{//   Close[0]
		?time--; time++;
		FileWriteInteger(hand1e,  time,   LONG_VALUE);//TimeCurrent()
		FileWriteDouble (hand1e,  ask[ArraySize(ask)-1], DOUBLE_VALUE);//Open[]
		FileWriteDouble (hand1e,  ask[ArraySize(ask)-1], DOUBLE_VALUE);//High[]
		FileWriteDouble (hand1e,  ask[ArraySize(ask)-1], DOUBLE_VALUE);//Low[]
		FileWriteDouble (hand1e,  ask[ArraySize(ask)-1], DOUBLE_VALUE);//Close[]
		FileWriteDouble (hand1e,  0, DOUBLE_VALUE);//Volume[]
		FileFlush       (hand1e);
		fpos = FileTell (hand1e);//    
	}
}

string ErrorDescription(int error_code){
	string error_string;
	switch(error_code){
   //---- codes returned from trade server
		case 0:
		case 1:   error_string="no error";                                                  break;
		case 2:   error_string="common error";                                              break;
		case 3:   error_string="invalid trade parameters";                                  break;
		case 4:   error_string="trade server is busy";                                      break;
		case 5:   error_string="old version of the client terminal";                        break;
		case 6:   error_string="no connection with trade server";                           break;
		case 7:   error_string="not enough rights";                                         break;
		case 8:   error_string="too frequent requests";                                     break;
		case 9:   error_string="malfunctional trade operation (never returned error)";      break;
		case 64:  error_string="account disabled";                                          break;
		case 65:  error_string="invalid account";                                           break;
		case 128: error_string="trade timeout";                                             break;
		case 129: error_string="invalid price";                                             break;
		case 130: error_string="invalid stops";                                             break;
		case 131: error_string="invalid trade volume";                                      break;
		case 132: error_string="market is closed";                                          break;
		case 133: error_string="trade is disabled";                                         break;
		case 134: error_string="not enough money";                                          break;
		case 135: error_string="price changed";                                             break;
		case 136: error_string="off quotes";                                                break;
		case 137: error_string="broker is busy (never returned error)";                     break;
		case 138: error_string="requote";                                                   break;
		case 139: error_string="order is locked";                                           break;
		case 140: error_string="long positions only allowed";                               break;
		case 141: error_string="too many requests";                                         break;
		case 145: error_string="modification denied because order too close to market";     break;
		case 146: error_string="trade context is busy";                                     break;
		case 147: error_string="expirations are denied by broker";                          break;
		case 148: error_string="amount of open and pending orders has reached the limit";   break;
		case 149: error_string="hedging is prohibited";                                     break;
		case 150: error_string="prohibited by FIFO rules";                                  break;
		//---- mql4 errors
		case 4000: error_string="no error (never generated code)";                          break;
		case 4001: error_string="wrong function pointer";                                   break;
		case 4002: error_string="array index is out of range";                              break;
		case 4003: error_string="no memory for function call stack";                        break;
		case 4004: error_string="recursive stack overflow";                                 break;
		case 4005: error_string="not enough stack for parameter";                           break;
		case 4006: error_string="no memory for parameter string";                           break;
		case 4007: error_string="no memory for temp string";                                break;
		case 4008: error_string="not initialized string";                                   break;
		case 4009: error_string="not initialized string in array";                          break;
		case 4010: error_string="no memory for array\' string";                             break;
		case 4011: error_string="too long string";                                          break;
		case 4012: error_string="remainder from zero divide";                               break;
		case 4013: error_string="zero divide";                                              break;
		case 4014: error_string="unknown command";                                          break;
		case 4015: error_string="wrong jump (never generated error)";                       break;
		case 4016: error_string="not initialized array";                                    break;
		case 4017: error_string="dll calls are not allowed";                                break;
		case 4018: error_string="cannot load library";                                      break;
		case 4019: error_string="cannot call function";                                     break;
		case 4020: error_string="expert function calls are not allowed";                    break;
		case 4021: error_string="not enough memory for temp string returned from function"; break;
		case 4022: error_string="system is busy (never generated error)";                   break;
		case 4050: error_string="invalid function parameters count";                        break;
		case 4051: error_string="invalid function parameter value";                         break;
		case 4052: error_string="string function internal error";                           break;
		case 4053: error_string="some array error";                                         break;
		case 4054: error_string="incorrect series array using";                             break;
		case 4055: error_string="custom indicator error";                                   break;
		case 4056: error_string="arrays are incompatible";                                  break;
		case 4057: error_string="global variables processing error";                        break;
		case 4058: error_string="global variable not found";                                break;
		case 4059: error_string="function is not allowed in testing mode";                  break;
		case 4060: error_string="function is not confirmed";                                break;
		case 4061: error_string="send mail error";                                          break;
		case 4062: error_string="string parameter expected";                                break;
		case 4063: error_string="integer parameter expected";                               break;
		case 4064: error_string="double parameter expected";                                break;
		case 4065: error_string="array as parameter expected";                              break;
		case 4066: error_string="requested history data in update state";                   break;
		case 4099: error_string="end of file";                                              break;
		case 4100: error_string="some file error";                                          break;
		case 4101: error_string="wrong file name";                                          break;
		case 4102: error_string="too many opened files";                                    break;
		case 4103: error_string="cannot open file";                                         break;
		case 4104: error_string="incompatible access to a file";                            break;
		case 4105: error_string="no order selected";                                        break;
		case 4106: error_string="unknown symbol";                                           break;
		case 4107: error_string="invalid price parameter for trade function";               break;
		case 4108: error_string="invalid ticket";                                           break;
		case 4109: error_string="trade is not allowed in the expert properties";            break;
		case 4110: error_string="longs are not allowed in the expert properties";           break;
		case 4111: error_string="shorts are not allowed in the expert properties";          break;
		case 4200: error_string="object is already exist";                                  break;
		case 4201: error_string="unknown object property";                                  break;
		case 4202: error_string="object is not exist";                                      break;
		case 4203: error_string="unknown object type";                                      break;
		case 4204: error_string="no object name";                                           break;
		case 4205: error_string="object coordinates error";                                 break;
		case 4206: error_string="no specified subwindow";                                   break;
		default:   error_string="unknown error";
    }
   return(error_string);
}